import middy from '@middy/core';
import { APIGatewayProxyEvent, APIGatewayProxyResult, Context, ScheduledEvent } from 'aws-lambda';
import { ObjectSchema } from 'joi';
export type APIGatewayHandlerFn = (event: APIGatewayProxyEvent, context: Context) => Promise<APIGatewayProxyResult>;
export type ScheduledHandlerFn = (event: ScheduledEvent, context: Context) => Promise<void>;
export type MiddyfyOptions<THandler> = {
    handler: THandler;
    logger?: (message: string) => void;
};
export type APIGatewayMiddyfyOptions = MiddyfyOptions<APIGatewayHandlerFn> & {
    eventSchema?: ObjectSchema;
    defaultErrorMessage?: string;
    defaultErrorStatusCode?: number;
};
export type ScheduledMiddyfyOptions = MiddyfyOptions<ScheduledHandlerFn> & {
    eventSchema?: ObjectSchema;
};
export declare const middyfyAPIGateway: (options: APIGatewayMiddyfyOptions) => middy.MiddyfiedHandler<APIGatewayProxyEvent & Omit<APIGatewayProxyEvent, "body"> & {
    body: import("type-fest").JsonValue;
} & {
    multiValueQueryStringParameters: import("aws-lambda").APIGatewayProxyEventMultiValueQueryStringParameters;
    pathParameters: import("aws-lambda").APIGatewayProxyEventPathParameters;
    queryStringParameters: import("aws-lambda").APIGatewayProxyEventQueryStringParameters;
}, APIGatewayProxyResult, Error, Context>;
export declare const middyfyScheduled: (options: ScheduledMiddyfyOptions) => middy.MiddyfiedHandler<ScheduledEvent<any>, void, Error, Context>;
